program NulWrite;

{$DEFINE DisableUTF8RTL}
{ $DEFINE DOS}
{ $DEFINE X86_64}
{ $DEFINE LINUX_32}
{ $DEFINE LINUX_64}
{$IFDEF LINUX_32} {$DEFINE LINUX} {$ENDIF}
{$IFDEF LINUX_64} {$DEFINE LINUX} {$ENDIF}
{$IFNDEF LINUX} {$IFNDEF DOS} {$DEFINE WIN_3264} {$ENDIF} {$ENDIF}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H-}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

USES NullUtil, Stdio, Zeit, CRT, DOS;

CONST VERSION_INFO = 'NulWrite   NULLDISK   V 2.88 ' +
{$IFDEF LINUX_32} '(Linux 32)' {$ELSE} {$IFDEF LINUX_64} '(Linux 64)' {$ELSE}
{$IFDEF DOS}      '(16bit)' {$ELSE}
{$IFDEF X86_64}   '(64bit)' {$ELSE} '(32bit)' {$ENDIF} {$ENDIF} {$ENDIF}
{$ENDIF} + ' 13.01.2021   (c) ALFWARE B.Schubert';

CONST SLASH = {$IFDEF LINUX} '/' {$ELSE} '\' {$ENDIF} ;

CONST PROTO_NULWRITE = {$IFDEF DOS} 'wr' {$ELSE} 'nulwrite' {$ENDIF};

procedure Hilfe;
begin
   Writeln;
   Writeln('Aufruf: NulWrite [groesse] [zeichen] [beginn] [anzahl]');
   Writeln('':17,'[loeschen] [verzeichnis] [protokoll]');
   Writeln;
   Writeln('groesse   Anzahl Bytes in der Datei (max. 1GByte!)');
   Writeln('          Zahl [+ K/M/G]','':32,'Werte: 1.. [1M] .. 1G');
   Writeln;
   Writeln('zeichen   Inhalt der Datei (n-mal)','':22,'Werte: [HEX = hex.00]');
   Writeln('          beliebiges (Sonder-)Zeichen','':26,'LEER, RND');
   Writeln;
   Writeln('beginn    kleinster Index fuer Dateien Nnnnnnnn.NUL     Werte: 0, [1] - 9999999');
   Writeln;
   Writeln('anzahl    Dateien/Wiederholungen ab "beginn"            Werte: [1] - 9999999');
   Writeln;
   Writeln('loeschen  Sollen Dateien automatisch geloescht werden?  Werte: [N(ein)] / J(a)');
   Writeln('':63,'A(lle) / L(eise)');
   Writeln;
   Writeln('verzeichnis fuer die Dateien (Standard: Aktuelles)      Werte: am besten leer!');
   Writeln;
   Writeln('protokoll schreibt Protokoll mit max n Eintraegen       Werte: [0] - 9999');
   Writeln;
   Writeln('Beispiel: NulWrite 50000 LEER 3 10 J');
   Writeln('Erzeugt N0000003.NUL - N0000012.NUL je 50.000 Spaces, anschliessend w.geloescht');
   Writeln;
   Writeln('Beispiel: Nulwrite');
   Writeln('schreibt solange Dateien N0000000.NUL - N9999999.NUL, wie es geht');
   Writeln('Es wird anschliessend NICHT geloescht, werden max 200 Durchlaeufe protokolliert');
   Halt;
end;

procedure Plausi;
Label plausi_ende;
begin
   if ParamCount = 0 then begin
      BEGINN:=0; ANZAHL:=9999999+1; ENDE:= BEGINN + ANZAHL-1; ZEICHEN:=Chr(00); GROESSE:=GIGA;
      LEISE:=false; LOESCHEN:='N'; SCHRITTE:=200; goto plausi_ende;
   end;
   KETTE:=ParamStr(1);
   if (KETTE = '/?') or (KETTE = '-?') or (KETTE = '?') or (KETTE = '/h') or (KETTE = '-h') then Hilfe;
   if KETTE = '' then KETTE:='1M';
   g:=Length(KETTE); gg:=g;
   if KETTE[g] in ['g','G','m','M','k','K'] then g:=g-1;
   Val(copy(KETTE, 1, g), GROESSE_KRUMM, c);
   if (c <> 0) or (GROESSE_KRUMM < 0.1) then Hilfe;
   if (KETTE[gg] in ['g','G']) then begin
      if (GROESSE_KRUMM > 1) then Hilfe;
      GROESSE_KRUMM:=GROESSE_KRUMM*GIGA;
   end;
   if (KETTE[gg] in ['m','M']) then begin
      if (GROESSE_KRUMM > KILO) then Hilfe;
      GROESSE_KRUMM:=GROESSE_KRUMM*MEGA;
   end;
   if (KETTE[gg] in ['k','K']) then begin
      if (GROESSE_KRUMM > MEGA) then Hilfe;
      GROESSE_KRUMM:=GROESSE_KRUMM*KILO;
   end;
   if (GROESSE_KRUMM > GIGA) then Hilfe;
   GROESSE:=TRUNC(GROESSE_KRUMM);
   KETTE:=ParamStr(2); ZUFALL:='N';
   if KETTE <> '' then begin;
      ZEICHEN:=KETTE [1];
      if (KETTE = 'HEX')    or (KETTE = 'hex')      then ZEICHEN:=Chr(00);
      if (KETTE = 'LEER')   or (KETTE = 'leer')  or
         (KETTE = 'NULL')   or (KETTE = 'null')     then ZEICHEN:=' ';
      if (KETTE = 'RND')    or (KETTE = 'rnd')   or
         (KETTE = 'RANDOM') or (KETTE = 'random')   then begin ZEICHEN:='*'; ZUFALL:='J'; end
   end
   else ZEICHEN:=Chr(00);
   if ParamCount < 3 then begin
      BEGINN:=0; ANZAHL:=9999999+1; ENDE:= BEGINN + ANZAHL-1;
      LEISE:=false; LOESCHEN:='N'; SCHRITTE:=200; goto plausi_ende;
   end;
   KETTE:=Paramstr(3);
   if KETTE = '' then KETTE:='1';
   Val(KETTE, BEGINN, c);
   if (c <> 0) or (BEGINN > 9999999) then Hilfe;
   KETTE:=Paramstr(4);
   if KETTE = '' then KETTE:='1';
   Val(KETTE, ANZAHL, c);
   if (c <> 0) or (ANZAHL < 1) or (ANZAHL + BEGINN > 9999999+1) then Hilfe;
   ENDE:=BEGINN+ANZAHL-1;
   KETTE:=ParamStr(5);
   if KETTE <> '' then begin;
      LOESCHEN:=upcase(KETTE [1]);
      if NOT(LOESCHEN in ['J','A']) then LOESCHEN:='N';
   end
   else LOESCHEN:='N';
   VERZEICHNIS:='';
   KETTE:=ParamStr(6);
   if (KETTE = '') or (KETTE = '*') or (KETTE = '.') or (KETTE = '..') or (KETTE = '\')
      then VERZEICHNIS:=''
      else begin
         VERZEICHNIS:=KETTE;
         if VERZEICHNIS[length(VERZEICHNIS)] <> '\' then VERZEICHNIS:=VERZEICHNIS + '\';
      end;
   KETTE:=Paramstr(7);
   if KETTE = ''
      then KETTE:= '0'
      else BEGIN LEISE:=false; SCHRITTE_AN:=true; end;
   Val(KETTE, SCHRITTE, c);
   if (c <> 0) then SCHRITTE:=200;
   if (SCHRITTE < 0) or (SCHRITTE > 9999) then Hilfe;
plausi_ende:
   if (SCHRITTE < 1) or not Frei_Protokoll then PROTO_AUS:=false;
   Writeln; Write('GROESSE     = ', GROESSE);
   if GROESSE >= KILO then Writeln(' (', Str0Giga(GROESSE) ,')') else Writeln;
   Write('ZEICHEN     = ');
   if ZUFALL = 'J'
      then Writeln('RANDOM -> daher langsamer!')
      else
         case ZEICHEN of
            Chr(00): Writeln('HEX');
            ' '    : Writeln('LEER');
            else     Writeln(ZEICHEN);
         end;
   Writeln('BEGINN      = ', Str0long(BEGINN,8), ' -> DATEI-VON=', 'N' + Str0long(BEGINN,7) + '.NUL');
   Writeln('ANZAHL      = ', Str0long(ANZAHL,8), ' -> DATEI-BIS=', 'N' + Str0long(ENDE,7) + '.NUL');
   Writeln('LOESCHEN    = ', LOESCHEN);
   if VERZEICHNIS <> '' then Writeln('VERZEICHNIS = ', VERZEICHNIS);
end;

begin
   ClrScr; Writeln(VERSION_INFO);
   Writeln; Writeln('Fuellt und loescht Dateien und Festplatten etc...');
   KETTE:=''; BEGINN:=1;  ANZAHL:=1; LOESCHEN:='N';
   GROESSE_ZEIGE:=0; GROESSE_RECHEN:=0; GROESSE_ANZAHL:=0;
   GROESSE_W:=0; GROESSE_PLUS:=0; OK:=0; GROESSE:=KILO; GROESSE_AKT:=0;
   ZEICHEN:='*'; ZUFALL:='N'; Randomize; ZEILE_MAGIC:=0;

   Start_Verzeichnis('nulldisk');
   Plausi;
   Datentraeger_Frei;

   NULL_ZEIT:=Intervall_Start(1);
   Check_Protokoll_AUS;
   if PROTO_AUS then begin
      Protokoll_Name(PROTO_NULWRITE);
      Assign(PROTOKOLL, PROTO_VERZEICHNIS + PROTO_NAME); {$I-} Rewrite(PROTOKOLL); {$I+}
      Writeln(PROTOKOLL, NULL_ZEIT); Intervall_Start(3); Intervall_Start(4);
      Writeln(PROTOKOLL);
   end;
   Writeln; Writeln('Beende mit Tastendruck...');
   if GROESSE > MAX then GROESSE_AKT:=MAX else GROESSE_AKT:=GROESSE;
   for f:=1 to GROESSE_AKT do FELD[f]:=ZEICHEN;

   EXT:=BEGINN; GROESSE_ALLE:=GROESSE;
   if VERZEICHNIS<>'' then Make_Directory(VERZEICHNIS,'');
   AUS:=0; DATEI_ANZAHL:=ANZAHL; LAST:=BEGINN-1;
   if PROTO_AUS then Bestimme_Schritte_Protokoll;

   repeat
      GROESSE:=GROESSE_ALLE; Intervall_Start(2);
      Assign(DATEI, VERZEICHNIS + 'N' + Str0long(EXT,7) + '.NUL');
      Rewrite(DATEI, 1); Writeln; null_stop:=true;
      repeat

         if ZUFALL='J'then begin;
            for f:=1 to GROESSE_AKT do FELD[f]:=Chr(Random(256));
         end;
         if GROESSE > MAX then GROESSE_AKT:=MAX else GROESSE_AKT:=GROESSE;
         GROESSE:=GROESSE - GROESSE_AKT;

         if DATEN_HOME = PROTO_HOME
            then io_bw:= Diskfree(DATEN_HOME) >= GROESSE_AKT + GROESSE_PROTO_WRITE
            else io_bw:= (Diskfree(DATEN_HOME) >= GROESSE_AKT) and
                         (Diskfree(PROTO_HOME) >= GROESSE_PROTO_WRITE);

	 if io_bw then begin
            {$I-} BlockWrite(DATEI, FELD, GROESSE_AKT, GROESSE_W); {$I+}
            io:=IOResult;

            if DATEN_HOME = PROTO_HOME
               then io_bw:= Diskfree(DATEN_HOME) >= GROESSE_AKT + GROESSE_PROTO_WRITE
               else io_bw:= (Diskfree(DATEN_HOME) >= GROESSE_AKT) and
                            (Diskfree(PROTO_HOME) >= GROESSE_PROTO_WRITE);

            io_bw:=(io = 0) and io_bw and (GROESSE_W > 0);
         end;

         GROESSE_PLUS:=GROESSE_PLUS + GROESSE_AKT;
         Ausgabe_Megabyte;

      until (GROESSE < 1) or KeyPressed or not io_bw;

      if ZEILE_MAGIC > 0 then begin
         WriteLn;
	 if GROESSE_ALLE >= 50*MEGA then Writeln('Schreibe Cache');
      end;
      if GROESSE < 1 then begin Ausgabe_Summe; inc(EXT); end;

      if (not io_bw) or keypressed then begin
         EXT:= BEGINN + ANZAHL+1;
         if keypressed then inc(OK);
      end;

      Close(DATEI);

   until EXT >= BEGINN + ANZAHL;

   NULL_ZEIT:=Intervall_Stop(1);
   if PROTO_AUS then begin
      Writeln(PROTOKOLL);
      Writeln(PROTOKOLL, NULL_ZEIT + '   ' + Intervall_Dauer(1) + '   Gesamtzeit');
      if OK < 1 then OK:=1; durchschnitt:= Diff_Moment.rsekunde / OK;
      Writeln(PROTOKOLL);
      Writeln(PROTOKOLL, 'Durchschnittlich: ', durchschnitt: {$IFDEF X86_64} 4:3 {$ELSE} 3:2 {$ENDIF},
                         ' sek pro ', Str0Giga(GROESSE_ALLE) + ' Datei (', OK ,')');
      Close(PROTOKOLL);
   end;
   Loeschen_Alle;
   if PROTO_AUS then Zeige_Protokoll;
   if not NULL_STOP then Writeln; Writeln('NulWrite ist beendet.   ' + Intervall_Dauer(1));
end (* NulWrite *).
